#!/usr/bin/perl -w -I/usr/sausalito/perl

use CCE;
use Sauce::Service;
use Sauce::Util;
use Sauce::Validators;

sub update_ntp_conf {
	my ($fin, $fout, $ntpAddress) = @_;
	print $fout "server    $ntpAddress\n";
	return 0;
}

# defines that should probably go elsewhere
my $NTPconf = '/etc/ntp.conf';
my $ntpd = 'ntpd';
my $tickers = '/etc/ntp/step-tickers';

my $cce = new CCE ( Namespace => "Time" );
$cce->connectfd();

my $time_obj = $cce->event_object();

# set the ntp Address and toggle the ntp server based upon its existence
my $ntpAddress = $time_obj->{ntpAddress};
if ($ntpAddress) {
	# ntp server defined
	if ( ! Sauce::Validators::netaddr ( $ntpAddress )) {
		$cce->baddata(0, 'ntpAddress', "[[base-time.ntpAddress_invalid]]");
	} else {
		# NTP address is good,    update the conf file	
		Sauce::Util::editblock( $NTPconf, *update_ntp_conf,
					'# begin Cobalt Section',
					'# end Cobalt Section',
					$ntpAddress) && 
			$cce->warn("[[base-time.errorWritingConfFile]]");

		# set the time on system startup
		`echo '$ntpAddress' > $tickers`;
	}  
}
Sauce::Service::service_toggle_init($ntpd, $ntpAddress);

# this is used by other objects
my @oids = $cce->find('System');
if ($#oids > -1) {
	my $new = $ntpAddress ? 't' : '';
	my $old = $time_obj->{ntpEnabled} ? 't' : '';
	$cce->set($oids[0], 'Time', 
		 { 'ntpEnabled' => $new }) if ($old ne $new);
}
$cce->bye('SUCCESS');
exit 0;
