#!/usr/bin/perl 

use lib '/usr/sausalito/perl';
use CCE;

my $cce = new CCE(Namespace => 'Time');
$cce->connectfd();

my $localtime = '/etc/localtime';
my $time_obj = $cce->event_object();
my $old = $cce->event_old();


# set the timezone first
my $zone = $time_obj->{timeZone};
my $link = '../usr/share/zoneinfo/' . $zone;
if ($zone and (readlink($localtime) ne $link)) {
	unlink('/etc/localtime');
	symlink($link, '/etc/localtime');
}

# set the time if necessary. don't bother setting it if we're using
# NTP.
my $time = $time_obj->{epochTime};
my $ntp = $time_obj->{ntpAddress};
unless (($time eq $old->{epochTime}) or $ntp) {
    `/usr/sausalito/sbin/epochdate $time`;
    # resync the hwclock with the time
    system ("/sbin/hwclock --utc --systohc > /dev/null");
    unlink("/etc/adjtime"); # get rid of any clock skew
    system ("/sbin/hwclock --utc --systohc > /dev/null");
}

$cce->bye("SUCCESS");
exit 0;
